Package com.io7m.jregions.core.unparameterized.volumes

# Class VolumeXYZSplitD<T extends VolumeDType>

java.lang.Object
com.io7m.jregions.core.unparameterized.volumes.VolumeXYZSplitD<T>

Type Parameters:
  `T` - The precise type of volume

All Implemented Interfaces:
  `VolumeXYZSplitDType<T>`

    public final class VolumeXYZSplitD<T extends VolumeDType>
    extends java.lang.Object
    implements VolumeXYZSplitDType<T>

A volume that has been split into octants via an X, Y, and Z axis.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `VolumeXYZSplitD.Builder<T extends VolumeDType>` | Builds instances of type `VolumeXYZSplitD`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static <T extends VolumeDType> VolumeXYZSplitD.Builder<T>` | `builder()` | Creates a builder for `VolumeXYZSplitD`.
  `static <T extends VolumeDType> VolumeXYZSplitD<T>` | `copyOf​(VolumeXYZSplitDType<T> instance)` | Creates an immutable copy of a `VolumeXYZSplitDType` value.
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `VolumeXYZSplitD` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `x0y0z0`, `x1y0z0`, `x0y1z0`, `x1y1z0`, `x0y0z1`, `x1y0z1`, `x0y1z1`, `x1y1z1`.
  `static <T extends VolumeDType> VolumeXYZSplitD<T>` | `of​(T x0y0z0, T x1y0z0, T x0y1z0, T x1y1z0, T x0y0z1, T x1y0z1, T x0y1z1, T x1y1z1)` | Construct a new immutable `VolumeXYZSplitD` instance.
  `java.lang.String` | `toString()` | Prints the immutable value `VolumeXYZSplitD` with attribute values.
  `VolumeXYZSplitD<T>` | `withX0y0z0​(T value)` | Copy the current immutable object by setting a value for the `x0y0z0` attribute.
  `VolumeXYZSplitD<T>` | `withX0y0z1​(T value)` | Copy the current immutable object by setting a value for the `x0y0z1` attribute.
  `VolumeXYZSplitD<T>` | `withX0y1z0​(T value)` | Copy the current immutable object by setting a value for the `x0y1z0` attribute.
  `VolumeXYZSplitD<T>` | `withX0y1z1​(T value)` | Copy the current immutable object by setting a value for the `x0y1z1` attribute.
  `VolumeXYZSplitD<T>` | `withX1y0z0​(T value)` | Copy the current immutable object by setting a value for the `x1y0z0` attribute.
  `VolumeXYZSplitD<T>` | `withX1y0z1​(T value)` | Copy the current immutable object by setting a value for the `x1y0z1` attribute.
  `VolumeXYZSplitD<T>` | `withX1y1z0​(T value)` | Copy the current immutable object by setting a value for the `x1y1z0` attribute.
  `VolumeXYZSplitD<T>` | `withX1y1z1​(T value)` | Copy the current immutable object by setting a value for the `x1y1z1` attribute.
  `T` | `x0y0z0()` |
  `T` | `x0y0z1()` |
  `T` | `x0y1z0()` |
  `T` | `x0y1z1()` |
  `T` | `x1y0z0()` |
  `T` | `x1y0z1()` |
  `T` | `x1y1z0()` |
  `T` | `x1y1z1()` |

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### x0y0z0

    public T x0y0z0()
    Specified by:
      `x0y0z0` in interface `VolumeXYZSplitDType<T extends VolumeDType>`
    Returns:
      The minimum X, minimum Y, minimum Z octant

  - ### x1y0z0

    public T x1y0z0()
    Specified by:
      `x1y0z0` in interface `VolumeXYZSplitDType<T extends VolumeDType>`
    Returns:
      The maximum X, minimum Y, minimum Z octant

  - ### x0y1z0

    public T x0y1z0()
    Specified by:
      `x0y1z0` in interface `VolumeXYZSplitDType<T extends VolumeDType>`
    Returns:
      The minimum X, maximum Y, minimum Z octant

  - ### x1y1z0

    public T x1y1z0()
    Specified by:
      `x1y1z0` in interface `VolumeXYZSplitDType<T extends VolumeDType>`
    Returns:
      The maximum X, maximum Y, minimum Z octant

  - ### x0y0z1

    public T x0y0z1()
    Specified by:
      `x0y0z1` in interface `VolumeXYZSplitDType<T extends VolumeDType>`
    Returns:
      The minimum X, minimum Y, maximum Z octant

  - ### x1y0z1

    public T x1y0z1()
    Specified by:
      `x1y0z1` in interface `VolumeXYZSplitDType<T extends VolumeDType>`
    Returns:
      The maximum X, minimum Y, maximum Z octant

  - ### x0y1z1

    public T x0y1z1()
    Specified by:
      `x0y1z1` in interface `VolumeXYZSplitDType<T extends VolumeDType>`
    Returns:
      The minimum X, maximum Y, maximum Z octant

  - ### x1y1z1

    public T x1y1z1()
    Specified by:
      `x1y1z1` in interface `VolumeXYZSplitDType<T extends VolumeDType>`
    Returns:
      The maximum X, maximum Y, maximum Z octant

  - ### withX0y0z0

    public final VolumeXYZSplitD<T> withX0y0z0​(T value)
    Copy the current immutable object by setting a value for the `x0y0z0` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x0y0z0
    Returns:
      A modified copy of the `this` object

  - ### withX1y0z0

    public final VolumeXYZSplitD<T> withX1y0z0​(T value)
    Copy the current immutable object by setting a value for the `x1y0z0` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x1y0z0
    Returns:
      A modified copy of the `this` object

  - ### withX0y1z0

    public final VolumeXYZSplitD<T> withX0y1z0​(T value)
    Copy the current immutable object by setting a value for the `x0y1z0` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x0y1z0
    Returns:
      A modified copy of the `this` object

  - ### withX1y1z0

    public final VolumeXYZSplitD<T> withX1y1z0​(T value)
    Copy the current immutable object by setting a value for the `x1y1z0` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x1y1z0
    Returns:
      A modified copy of the `this` object

  - ### withX0y0z1

    public final VolumeXYZSplitD<T> withX0y0z1​(T value)
    Copy the current immutable object by setting a value for the `x0y0z1` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x0y0z1
    Returns:
      A modified copy of the `this` object

  - ### withX1y0z1

    public final VolumeXYZSplitD<T> withX1y0z1​(T value)
    Copy the current immutable object by setting a value for the `x1y0z1` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x1y0z1
    Returns:
      A modified copy of the `this` object

  - ### withX0y1z1

    public final VolumeXYZSplitD<T> withX0y1z1​(T value)
    Copy the current immutable object by setting a value for the `x0y1z1` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x0y1z1
    Returns:
      A modified copy of the `this` object

  - ### withX1y1z1

    public final VolumeXYZSplitD<T> withX1y1z1​(T value)
    Copy the current immutable object by setting a value for the `x1y1z1` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x1y1z1
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `VolumeXYZSplitD` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `x0y0z0`, `x1y0z0`, `x0y1z0`, `x1y1z0`, `x0y0z1`, `x1y0z1`, `x0y1z1`, `x1y1z1`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `VolumeXYZSplitD` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### of

    public static <T extends VolumeDType> VolumeXYZSplitD<T> of​(T x0y0z0, T x1y0z0, T x0y1z0, T x1y1z0, T x0y0z1, T x1y0z1, T x0y1z1, T x1y1z1)
    Construct a new immutable `VolumeXYZSplitD` instance.
    Type Parameters:
      `T` - generic parameter T
    Parameters:
      `x0y0z0` - The value for the `x0y0z0` attribute
      `x1y0z0` - The value for the `x1y0z0` attribute
      `x0y1z0` - The value for the `x0y1z0` attribute
      `x1y1z0` - The value for the `x1y1z0` attribute
      `x0y0z1` - The value for the `x0y0z1` attribute
      `x1y0z1` - The value for the `x1y0z1` attribute
      `x0y1z1` - The value for the `x0y1z1` attribute
      `x1y1z1` - The value for the `x1y1z1` attribute
    Returns:
      An immutable VolumeXYZSplitD instance

  - ### copyOf

    public static <T extends VolumeDType> VolumeXYZSplitD<T> copyOf​(VolumeXYZSplitDType<T> instance)
    Creates an immutable copy of a `VolumeXYZSplitDType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Type Parameters:
      `T` - generic parameter T
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VolumeXYZSplitD instance

  - ### builder

    public static <T extends VolumeDType> VolumeXYZSplitD.Builder<T> builder()
    Creates a builder for `VolumeXYZSplitD`.

         VolumeXYZSplitD.&lt;T&gt;builder()
            .setX0y0z0(T) // required x0y0z0
            .setX1y0z0(T) // required x1y0z0
            .setX0y1z0(T) // required x0y1z0
            .setX1y1z0(T) // required x1y1z0
            .setX0y0z1(T) // required x0y0z1
            .setX1y0z1(T) // required x1y0z1
            .setX0y1z1(T) // required x0y1z1
            .setX1y1z1(T) // required x1y1z1
            .build();

    Type Parameters:
      `T` - generic parameter T
    Returns:
      A new VolumeXYZSplitD builder